diff --git a/libavcodec/decode.c b/libavcodec/decode.c
index b3e4b066e5..080edb5996 100644
--- a/libavcodec/decode.c
+++ b/libavcodec/decode.c
@@ -292,33 +292,12 @@ static int64_t guess_correct_pts(AVCodecContext *ctx,
 static int discard_samples(AVCodecContext *avctx, AVFrame *frame, int64_t *discarded_samples)
 {
     AVCodecInternal *avci = avctx->internal;
-    int ret = 0;
     uint8_t *side;
     size_t side_size;
     uint32_t discard_padding = 0;
     uint8_t skip_reason = 0;
     uint8_t discard_reason = 0;
 
-    if (frame->format == AV_SAMPLE_FMT_NONE)
-        frame->format = avctx->sample_fmt;
-    if (!frame->ch_layout.nb_channels) {
-        int ret2 = av_channel_layout_copy(&frame->ch_layout, &avctx->ch_layout);
-        if (ret2 < 0) {
-            ret = ret2;
-        }
-    }
-#if FF_API_OLD_CHANNEL_LAYOUT
-FF_DISABLE_DEPRECATION_WARNINGS
-    if (!frame->channel_layout)
-        frame->channel_layout = avctx->ch_layout.order == AV_CHANNEL_ORDER_NATIVE ?
-                                avctx->ch_layout.u.mask : 0;
-    if (!frame->channels)
-        frame->channels = avctx->ch_layout.nb_channels;
-FF_ENABLE_DEPRECATION_WARNINGS
-#endif
-    if (!frame->sample_rate)
-        frame->sample_rate = avctx->sample_rate;
-
     side = av_packet_get_side_data(avci->last_pkt_props, AV_PKT_DATA_SKIP_SAMPLES, &side_size);
     if (side && side_size >= 10) {
         avci->skip_samples = AV_RL32(side);
@@ -400,7 +379,7 @@ FF_ENABLE_DEPRECATION_WARNINGS
         }
     }
 
-    return ret;
+    return 0;
 }
 
 /*
@@ -450,14 +429,6 @@ FF_DISABLE_DEPRECATION_WARNINGS
                 frame->pkt_pos = pkt->pos;
 FF_ENABLE_DEPRECATION_WARNINGS
 #endif
-            //FIXME these should be under if(!avctx->has_b_frames)
-            /* get_buffer is supposed to set frame parameters */
-            if (!(avctx->codec->capabilities & AV_CODEC_CAP_DR1)) {
-                if (!frame->sample_aspect_ratio.num)  frame->sample_aspect_ratio = avctx->sample_aspect_ratio;
-                if (!frame->width)                    frame->width               = avctx->width;
-                if (!frame->height)                   frame->height              = avctx->height;
-                if (frame->format == AV_PIX_FMT_NONE) frame->format              = avctx->pix_fmt;
-            }
         }
     }
     emms_c();
@@ -619,8 +590,39 @@ static int decode_receive_frame_internal(AVCodecContext *avctx, AVFrame *frame)
     }
 
     if (!ret) {
-        if (avctx->codec_type != AVMEDIA_TYPE_VIDEO)
+        if (avctx->codec_type == AVMEDIA_TYPE_VIDEO) {
+            /* get_buffer is supposed to set frame parameters */
+            if (!(avctx->codec->capabilities & AV_CODEC_CAP_DR1)) {
+                if (!frame->sample_aspect_ratio.num)  frame->sample_aspect_ratio = avctx->sample_aspect_ratio;
+                if (!frame->width)                    frame->width               = avctx->width;
+                if (!frame->height)                   frame->height              = avctx->height;
+                if (frame->format == AV_PIX_FMT_NONE) frame->format              = avctx->pix_fmt;
+            }
+        } else if (avctx->codec->type == AVMEDIA_TYPE_AUDIO) {
+            if (frame->format == AV_SAMPLE_FMT_NONE)
+                frame->format = avctx->sample_fmt;
+            if (!frame->ch_layout.nb_channels) {
+                ret = av_channel_layout_copy(&frame->ch_layout, &avctx->ch_layout);
+                if (ret < 0) {
+                    av_frame_unref(frame);
+                    return ret;
+                }
+            }
+#if FF_API_OLD_CHANNEL_LAYOUT
+FF_DISABLE_DEPRECATION_WARNINGS
+            if (!frame->channel_layout)
+                frame->channel_layout = avctx->ch_layout.order == AV_CHANNEL_ORDER_NATIVE ?
+                                        avctx->ch_layout.u.mask : 0;
+            if (!frame->channels)
+                frame->channels = avctx->ch_layout.nb_channels;
+FF_ENABLE_DEPRECATION_WARNINGS
+#endif
+            if (!frame->sample_rate)
+                frame->sample_rate = avctx->sample_rate;
+
             frame->flags |= AV_FRAME_FLAG_KEY;
+        }
+
 #if FF_API_FRAME_KEY
 FF_DISABLE_DEPRECATION_WARNINGS
         frame->key_frame = !!(frame->flags & AV_FRAME_FLAG_KEY);